=== debian/changelog ===
vvdec-dmo (3.1.0-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Wed, 19 Nov 2025 08:44:21 +0100
