=== debian/control ===
Source: vvdec-dmo
Section: video
Priority: optional
Maintainer: Christian Marillat <marillat@deb-multimedia.org>
Bugs: mailto:marillat@deb-multimedia.org
Homepage: https://github.com/fraunhoferhhi/vvenc/releases
Standards-Version: 4.7.2
Build-Depends: debhelper-compat (= 13), cmake (>= 3.13.0~), ninja-build

Package: vvdec
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Fraunhofer Versatile Video Decoder (VVdeC)
 Versatile Video Coding (VVC) is the most recent international video coding
 standard, developed by the Joint Video Experts Team (JVET) of the ITU-T
 Video Coding Experts Group (VCEG) and the ISO/IEC Moving Picture Experts
 Group (MPEG). VVC is the successor of the High Efficiency Video Coding
 (HEVC) standard and will be released by ITU-T as H.266 and by ISO/IEC as
 MPEG-I Part 3 (ISO/IEC 23090-3). The new standard targets a 50% bit-rate
 reduction over HEVC at the same visual quality. In addition, VVC proves to
 be truly versatile by including tools for efficient coding of video content
 in emerging applications, e.g. high dynamic range (HDR), adaptive
 streaming, computer generated content as well as immersive applications like
 360 degree video and augmented reality (AR).
 .
 The Fraunhofer Versatile Video Decoder (VVdeC) is a fast VVC x86 software
 decoder implementation. The decoder supports most standard features
 available in the Main10 profile, with support for some high-level features
 still pending.

Package: libvvdec3
Architecture: any
Section: libs
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Fraunhofer Versatile Video Decoder - runtime files.
 Versatile Video Coding (VVC) is the most recent international video coding
 standard, developed by the Joint Video Experts Team (JVET) of the ITU-T
 Video Coding Experts Group (VCEG) and the ISO/IEC Moving Picture Experts
 Group (MPEG). VVC is the successor of the High Efficiency Video Coding
 (HEVC) standard and will be released by ITU-T as H.266 and by ISO/IEC as
 MPEG-I Part 3 (ISO/IEC 23090-3). The new standard targets a 50% bit-rate
 reduction over HEVC at the same visual quality. In addition, VVC proves to
 be truly versatile by including tools for efficient coding of video content
 in emerging applications, e.g. high dynamic range (HDR), adaptive
 streaming, computer generated content as well as immersive applications like
 360 degree video and augmented reality (AR).
 .
 The Fraunhofer Versatile Video Decoder (VVdeC) is a fast VVC x86 software
 decoder implementation. The decoder supports most standard features
 available in the Main10 profile, with support for some high-level features
 still pending.
 .
 This package contains the shared library.

Package: libvvdec-dev
Architecture: any
Section: libdevel
Multi-Arch: same
Depends: libvvdec3 (= ${binary:Version}), ${misc:Depends}
Description: Fraunhofer Versatile Video Decoder - devel files.
 Versatile Video Coding (VVC) is the most recent international video coding
 standard, developed by the Joint Video Experts Team (JVET) of the ITU-T
 Video Coding Experts Group (VCEG) and the ISO/IEC Moving Picture Experts
 Group (MPEG). VVC is the successor of the High Efficiency Video Coding
 (HEVC) standard and will be released by ITU-T as H.266 and by ISO/IEC as
 MPEG-I Part 3 (ISO/IEC 23090-3). The new standard targets a 50% bit-rate
 reduction over HEVC at the same visual quality. In addition, VVC proves to
 be truly versatile by including tools for efficient coding of video content
 in emerging applications, e.g. high dynamic range (HDR), adaptive
 streaming, computer generated content as well as immersive applications like
 360 degree video and augmented reality (AR).
 .
 The Fraunhofer Versatile Video Decoder (VVdeC) is a fast VVC x86 software
 decoder implementation. The decoder supports most standard features
 available in the Main10 profile, with support for some high-level features
 still pending.
 .
 This package contains headers and a static library.
