=== debian/rules ===
#!/usr/bin/make -f

ifeq ($(DEB_HOST_ARCH_CPU),arm64)
	confflags=-DVVDEC_ENABLE_ARM_SIMD=ON
else
	confflags=-DVVDEC_ENABLE_ARM_SIMD=OFF
endif

ifeq ($(DEB_HOST_ARCH_CPU),powerpc)
	confflags+=-DVVDEC_ENABLE_WERROR=OFF
endif

%:
	dh $@ -Scmake+ninja

override_dh_auto_configure:
	dh_auto_configure -- \
	-DBUILD_SHARED_LIBS=ON \
	-DCMAKE_BUILD_TYPE=RelWithDebInfo \
	-DCMAKE_SKIP_INSTALL_RPATH=ON \
	-DVVDEC_ENABLE_INSTALL=ON \
	-DVVDEC_ENABLE_LINK_TIME_OPT=OFF \
	-DVVDEC_ENABLE_WERROR=OFF \
	-DVVDEC_ENABLE_X86_SIMD=ON \
	-DVVDEC_INSTALL_VVDECAPP=ON \
	$(confflags)

#	exit 1

override_dh_clean:
	dh_clean

	rm -rf bin
	rm -rf lib

override_dh_auto_test:
