=== debian/watch ===
version=4

https://github.com/fraunhoferhhi/vvdec/tags \
(?:.*?/)?v?(\d[\d.]*)@ARCHIVE_EXT@
